// C Source File
// Created 6/16/01; 8:58:14 PM
// ASH Copyright (C) by Greg Dietsche 2001, 2002.

//AutoComplete.c

#define NO_EXIT_SUPPORT
#define NO_CALC_DETECT
#define NO_AMS_CHECK
#define OPTIMIZE_ROM_CALLS

#include <tigcclib.h>

#include "SearchEngine.h"
#include "Main.h"
#include "Misc.h"
#include "AutoComplete.h"

void AutoComplete(char c, char special)
{
	int x;										 //it's a slave OK...
	char *hstext;						  //pointer to the home screen entry line text
	char *pastestr;		 			 //pointer to the autocomplete string
	unsigned char pastelen;	//number of characters in pasetstr
	TEXT_EDIT *hste=ghste; //this is to decrease the size of the program
	
	if(!special)
	{
	//make the convert char have an ans(1) before it if the buffer is at 0
	//	Change CurSize to CursorOffset for a calc on steroids
		if(hste->CurSize==0 && (c==convert || c=='_'))
			TE_pasteText(hste,"ans(1)",6);
			
	//Paste the pressed key	
		TE_pasteText(hste,&c,1);
	}
	else
	{
		//make sure that nothing is selected
		EVENT ev;
		
		//if(hste->Flags & TE_SELECTED)
		//{
			ev.Type=CM_KEYPRESS;
		
		ev.extra.Key.Code=' ';
		TE_handleEvent(hste,&ev);
		
			ev.extra.Key.Code=KEY_BACKSPACE;
			TE_handleEvent(hste,&ev);
		//}
	}
		
	//Look to find an auto complete string to fill in the blank
		hstext=HeapDeref(hste->Text.h);
		x=hste->CursorOffset;

	//See if the cursor is in front of a letter... if so then just return
	//because ac-ing could get annoying in this case...
		if(isalpha(hstext[x]))
			 	return;

	//find the beginning of the word that should be aced
		
		//save the current character
		c=hstext[x];
		
		//make it a zero to fool FindFirst then decrement for the loop
		hstext[x--]=0;
		
		for(;x>-1;x--)
			{
			//the following characters mark the beginning of a new word
				if(hstext[x]=='(' ||
					 hstext[x]==')'	||
				 	 hstext[x]==',' ||
				 	 hstext[x]==':' ||
				 	 hstext[x]=='"'	||
				 	 hstext[x]=='{' ||
				 	 hstext[x]=='[' ||
				 	 hstext[x]=='=' ||
				 	 hstext[x]=='+'	||
				 	 hstext[x]=='-'	||
				 	 hstext[x]=='*'	||
				 	 hstext[x]=='/'	||
				 	 hstext[x]=='^'	||
				 	 hstext[x]=='|'	||
				 	 hstext[x]=='<' ||
				 	 hstext[x]=='>' ||
				 	 hstext[x]=='!' ||
				 	 hstext[x]==22	||								//the -> store arrow
				 	 (unsigned char)hstext[x]==173 ||	// - sign 173
				 	 (unsigned char)hstext[x]==156 ||	//=< sign 156
				 	 (unsigned char)hstext[x]==157 ||	//!= sign 157
				 	 (unsigned char)hstext[x]==158 ||	//=> sign 158
					 isdigit(hstext[x]))
				{
					break;
				}
				else
					if(hstext[x]==' ')
					{// ...are special (both seperators and valid act character(s?)
						x--;	//decrement so x++ brings us back to the correct place
						break;
					}
			}
	//comming out of the loop, x is always 1 less than
	//what it should be
		x++;
		
	//See if there is a match in the catalog
	if(special) //dialog or normal act?
	{//dialog
		ACPopUp(&hstext[x]);
		return;
	}

//Find a match for auto completion
	pastestr=FindFirst(&hstext[x]);
		
	//Restore the wierd character that got waxxxxed
		hstext[hste->CursorOffset]=c;

	//if a string to autocomplete with was found then do it
		if(pastestr)
		{
		//to avoid problems if a heap compression occurs when pasting...
		//I've never actually had the problem, but if you put in a
		//HeapCompress() and don't do this, wierd things can happen
		//so if you want more safety add the following lines
		
			//char buff[255];
			//pastestr=strcpy(buff,pastestr);

		//Paste The Suggested Text
			TE_pasteText(hste,pastestr,pastelen=strlen(pastestr));
			
		//Select the Pasted Text
		/////////////////////////////////////////////////////////////////////			
		//This is a really weird bug...is it mine or TI's??
		//without the first statement, the cursor jumps into a kind of ghost
		//space  where anything typed is handled as usual, but the cursor is
		//in outer space until that happens... one more thing, it ONLY seems 
		//to happen when the user deselects text going from left to right after
		//a program selects text from the leading right edge of the buffer to 
		//the left...
		//////////////////////////////////////////////////////////////////////
			TE_select(hste,hste->CursorOffset-pastelen,
										 hste->CursorOffset-pastelen);

			TE_select(hste,hste->CursorOffset+pastelen,
										 hste->CursorOffset);

		//this is the code that should work...
		/*
			TE_select(hste,hste->CursorOffset,
				hste->CursorOffset-pastelen);
			*/	
		}

	return;
}
