// C Source File
// Created 6/16/01; 8:59:11 PM
// ASH Copyright (C) by Greg Dietsche 2001, 2002.

#define NO_EXIT_SUPPORT
#define NO_CALC_DETECT
#define NO_AMS_CHECK
#define OPTIMIZE_ROM_CALLS

#include <tigcclib.h>

#include "OpenASHdb.h"
#include "Main.h"
#include "EnterHandler.h"
#include "AutoStart.h"

void EnterHandler(void)
{
	TEXT_EDIT *hste=ghste;	//to decrease the program size
	void *ptr;
	char *HomeText=HeapDeref(hste->Text.h);

//find the database if it does not exist then skip the search & replace for
//aliases
	if((ptr=OpenASHdb()))
	{
		ptr+=*(int*)(ptr+4);	//second word is the offset to the Aliases
												//from the beginning of the file
									
		while(*(char*)ptr)	//while the length byte is not null
		{		
			SearchAndReplace(hste,ptr+1,ptr+strlen(ptr)+1);
			ptr+=(*(char*)ptr);//go on to the next entry
		}
		
		//just in case the pointer changed during a SearchAndReplace(
		HomeText=HeapDeref(hste->Text.h);
	}
	
	AutoStart();	//runs a program if it is asm or ppg
}


//this routine could cause heap compression(s)!
//searches for the substring str in the TEXT EDITOR
//and replaces all occurences with replace
//it is smart however... so not every occurrence of search will be replaced
void SearchAndReplace(TEXT_EDIT* hste, char *search, char *replace)
{
	char *ptr=(HeapDeref(hste->Text.h));
	short lens=strlen(search);
	short lenr=strlen(replace);
	char bsearch[lens+1];
	char breplace[lenr+1];
	register short x=0;
	
	//to avoid problems if HeapCompress() takes place
		search=strcpy(bsearch,search);
		replace=strcpy(breplace,replace);
		
	while(ptr[x])
	{
		if(!memcmp(&ptr[x],replace,lenr))
		{
			x+=lenr;
		}
		else
		if(!memcmp(&ptr[x],search,lens))
		{
			//complete the alias only if these conditions are met
			if(x<1 || (!isalpha(ptr[x-1]) && ptr[x-1]!='\\' && checkquote(ptr,x,'\"')))
			{//strings.h
				TE_select(hste,x,x+lens);
				TE_pasteText(hste,replace,lenr);
				ptr=(HeapDeref(hste->Text.h));	//just in case of heap compression...
				x+=lenr;
			}
			else
			x++;
		}
		else
			x++;
	}
}

//if the # of quotes are not even, then ash assumes that
//the position in question is in a string and should not have an alias applied.
//this is a temporary patch
int checkquote(char *ptr, short x, char c)
{
//start at one so that i can write count%2 instead of !count%2
	unsigned short count = 1;
	
	while(x>-1)
	{
		if(ptr[x]==c)
			count++;
		x--;
	}
	
	return count%2;
}
