// C Source File
// Created 6/16/01; 8:57:39 PM
// ASH Copyright (C) by Greg Dietsche 2001, 2002.

#define NO_EXIT_SUPPORT
#define NO_CALC_DETECT
#define NO_AMS_CHECK
#define OPTIMIZE_ROM_CALLS

#include <tigcclib.h>

#include "ACPopUp.h"
#include "CustomMenu.h"
#include "EnterHandler.h"
#include "AutoComplete.h"
#include "Main.h"
#include "Misc.h"
#include "Handler.h"
#include "CallNextEV_hook.h"

void EventHandler(EVENT *ev)
{

	unsigned short rr=0;
	unsigned short c;
	unsigned short diamond=KEY_DIAMOND;
	short ti89=_ti89__;

	#ifdef OPTIMIZE_ROM_CALLS
		void *__saved_a5__;
		asm("/*START: Support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l %%a5,%0":"=p"(__saved_a5__));
		asm("move.l 0xC8,%a5");
		asm("/*END: Support for OPTIMIZE_ROM_CALLS*/");
	#endif

////////////////////////////////////////////////////////////////////////

#if 0
//used to find the meanings of the different bytes in the text editor flags...
	{
		char ccc[100];
		sprintf(ccc,"0x%hx",ghste->Flags);
		ST_helpMsg(ccc);
	}
	
#endif


	if(ev->Type==CM_KEYPRESS)
	{
			//Disable interrupts for _rowread
		OSSetSR(0x0700);
			rr=_rowread(~1);
		OSSetSR (0);	//restore 'em
		
		//I subscribe to the ONE KEY OFF philosophy... also set up the var c...
		//check for shift key then ignore for doorsos compat...
		
		if(((c=ev->extra.Key.Code)==KEY_ON) && (ti89?!(rr & 0x20):!(rr & 0x04)))
		{
			ev->extra.Key.Code=KEY_OFF;
		}
		else
		
		//c=ev->extra.Key.Code;//comment out this line when uncommenting one key on/off code
		
	//Does the Custom Menu need to be displayed
		if(ti89?
			(rr & 0x40) && (rr & 0x80) //Diamond + alpha on 89
			:
			(rr & 0x08) && (rr & 0x20))	//HAND + UP on 92+
		{
			if(ShowCustomMenu())
				ev->Type=CM_MENU_PASTE;
		}		
	else
	//Check to see if we are on the home screen and that 
	//	the text editor is active
		if((ghsWin->Flags & WF_ACTIVE) && (ghste->Flags & TE_ACTIVE))
		{//do stuff here if on home screen and a key was pressed

			if(c==diamond+KEY_MODE)
				c='_';
				
			//IsCompleteChar keys trapped for auto completing
			if(IsCompleteChar(c))
			{
				AutoComplete(c,FALSE);
					ev->Type=CM_IDLE;
			}
		else
		//a cast to char would be nice except it catches the F2 keypress
			if(c==KEY_ENTER || 
				 c==KEY_ENTER+diamond)
			{	
				EnterHandler();
			}
		else
		//support for the popup auto complete...
			if(ti89?
				(rr & 0x80) && (rr & 0x04)		//alpha + down on the 89
				:
				(rr & 0x08) && (rr &0x80))		//HAND + DOWN on the 92+
			{
				AutoComplete(0,TRUE);
				ev->Type=CM_IDLE;
			}
			
		}//end on home screen
	}	//end keypress

///////////////////////////////////////////////////////////////////////////
//Call the Old hook if there was one
//////////////////////////////////////////////////////////////////////////
  CallNextEV_hook(ev);


//pop the saved register off of the stack

	#ifdef OPTIMIZE_ROM_CALLS
		asm("/*START: Support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l %0, %%a5	/*support for OPTIMIZE_ROM_CALLS*/"::"p"(__saved_a5__));
		asm("/*END: Support for OPTIMIZE_ROM_CALLS*/");
	#endif

}
