// C Header File
// Created 3/22/01; 4:58:02 PM

#ifndef CompileDBh
#define CompileDBh

//FYI:
//ACT=Auto Complete Text

//function prototypes
void EmergencyCleanup(FILE* in, FILE* out, char* output);
void FindToken(char *Token, FILE *in);
int IsSpecial(char * buff,char * cmd, FILE* in);


int CompileTextFile(char *input, char *output)
{
		FILE *in;
		FILE *out;
		char i;
		int  x,z;
		char buff[255];
		
	//open the input file and return if error
		if(!(in=fopen(input,"r")))
		{
			ErrMessage(ER_BADINPUT);
			return 1;
		}
		
	//remove the output file if it exists
	//or return if it is archived...
		if(IsArchived(output))
		{
			fclose(in);
			ErrMessage(ER_ARCHIVED);
			return 1;
		}
		
		unlink(output);

	//open the output file
		out=fopen(output,"wb");

//The Tag that identifies a valid database 0xFFFF
	fwrite(&IDBShortTag,sizeof(unsigned int),1,out);
	
//set up the relative pointers to the different sections
//points to the act
	fputc(0,out);
	fputc(8,out);

//points to the Alias Commands
//this one will be filled in later
	fputc(0,out);
	fputc(0,out);

//points to the Custom Menu
//this one will be filled in later
	fputc(0,out);
	fputc(0,out);
	
//Get the Auto Complete Text
		FindToken(CmdACT,in);	//jump to the first ACT section
		
		while(fgets(buff,255,in))
		{
			if(IsSpecial(buff,CmdACT,in))
				continue;
				
			if(buff[z=strlen(buff)-1]=='\n')buff[z]=0;else z++;
			z+=2;
			
			if(z<4)			//if it is that small, it does not make sense to
				continue;	//include it in the database...
				
			fputc(z,out);
			fputs(buff,out);
			fputc(0,out);
		}
//End of Find AutoComplete Text
//zero terminate the list of ACT
//It should be possible to remove this to cause the aliases to be 
//included in the act section
	fputc(0,out);
	
//write the offset to the Alias Commands
	z=ftell(out);						 //save the current position
	fseek(out,4,SEEK_SET);	//move to the pointer for the Alias commands
	fwrite(&z,sizeof(int),1,out);	//write the info
	fseek(out,z,SEEK_SET);		 //move back to the original position
	
//Get the Alias Command Set
		fseek(in,0,SEEK_SET);	//jump to the beginning and go to work
		FindToken(CmdALIAS,in);	//find the first occurance of the Alias Commands
		
		while(fgets(buff,255,in))
		{
			if(IsSpecial(buff,CmdALIAS,in))
				continue;
				
		//the expected format is
		//ALIAS(NAME)
		//actual COMMAND NAME with a PATH if there is one to speak of.
			if(buff[z=strlen(buff)-1]=='\n')buff[z]=0;	//remove \n character

			x=ftell(out);	//save the position of the length byte
			fputc(0,out);	//length of entry byte

			i=strlen(buff);	//save the length of the first entry
			
			if(i<1)	//probably don't want it if it is this short...
			{
				EmergencyCleanup(in,out,output);
				ErrMessage(ER_BADALIAS);
				return 1;
			}
			
			fputs(buff,out);	//write the alias
			fputc(0,out);			//null terminate the string
			

			do
			{
				if(!fgets(buff,255,in))	//read the command path\name
				{
					EmergencyCleanup(in,out,output);
					ErrMessage(ER_BADALIAS);
					return 1;
				}
			}while(IsSpecial(buff,CmdALIAS,in));
			
			if(buff[z=strlen(buff)-1]=='\n')buff[z]=0;	//eat any \n characters
				
			if((z=strlen(buff))<2)
			{
				EmergencyCleanup(in,out,output);
				ErrMessage(ER_BADALIAS);
				return 1;
			}
				
			i+=z+3;	//add the length of the second part...
			fputs(buff,out);	 //write the path\name
			fputc(0,out);			//null terminate the string
			
			//write the length byte
				fseek(out,-1*i,SEEK_CUR);
				fwrite(&i,sizeof(char),1,out);
				fseek(out,i-1,SEEK_CUR);
		}
		
	//zero terminate the list of Aliases
		fputc(0,out);
//end of parse Alias Commands

//CmdCUST
//write the offset to the Custom Menu Structure
	z=ftell(out);						 //save the current position
	fseek(out,6,SEEK_SET);	//move to the pointer for CME
	fwrite(&z,sizeof(int),1,out);	//write the info
	fseek(out,z,SEEK_SET);		 //move back to the original position

//begin parse Custom Menu Entrise
		fseek(in,0,SEEK_SET);	//jump to the beginning and go to work
		FindToken(CmdCME,in);	//find the first occurance of CME
		
		while(fgets(buff,255,in))
		{
			if(IsSpecial(buff,CmdCME,in))
				continue;
		
		//remove \n character
			if(buff[z=strlen(buff)-1]=='\n')buff[z]=0;else z++;
			z+=2;
		
		//too short!  so skip it...
			if(z<3)
				continue;
				
			fputc(z,out);
			fputs(buff,out);
			fputc(0,out);
		}
	
	//zero terminate the list of CME
		if(fputc(0,out)==EOF)
		{
			EmergencyCleanup(in,out,output);
			ErrMessage(ER_LOWRAM);
			return 1;
		}
		
//end of parse Custom Menu Entries


		if(fwrite(CompiledTag,1,7,out)!=7)
		{//this is to trap any errors that happened like out of mem...
			//i think that i can get away with this... hopefully I'm correct
			EmergencyCleanup(in,out,output);
			ErrMessage(ER_LOWRAM);
			return 1;
		}
		
		fclose(in);
		fclose(out);
	
		return 0;
}

void EmergencyCleanup(FILE* in, FILE* out, char* output)
{
	fclose(in);
	fclose(out);
	unlink(output);
}


//enters a loop until a valid command string (Token) is found
void FindToken(char *Token, FILE *in)
{
	char buff[255];
	
	while(fgets(buff,255,in))
	{
		if(!strcmp(buff,Token))
			break;
	}
}


//checks for a comment or command token
//if a command token is found, but does not match,
//it will search until the end of the file looking
//for the correct command token before returning
//leaving the file input position in the updated position
int IsSpecial(char * buff,char * cmd, FILE* in)
{

			if(buff[0]=='*')
			{
					if(!strcmp(cmd,buff) || buff[1]=='*')
						return TRUE;
					
					FindToken(cmd,in);
						return TRUE;
				}
			
			return FALSE;
}
#endif
