// C Source File
// Created 6/18/01; 2:01:08 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#include <tigcclib.h>

#include "editdb.h"
#include "ConvertDB.h"

HANDLE ConvertDB(char *inptr, int mode)
{
	unsigned int allocsize;
	unsigned char len;
	unsigned int writepos=0;
	unsigned int readpos=0;
	
	volatile HANDLE h;
	char *txtptr;
	char *dbptr;
	
	allocsize=CONVERT_BUFFER_SIZE;
	if((h=HeapAlloc(allocsize))==H_NULL)
		return H_NULL;

//get the pointer for the text file...
	txtptr=HeapDeref(h);
	dbptr=inptr;

switch(mode)
{
	case CONVERT_ACT:
	//decompile act entries
		readpos=((IDBHeader*)inptr)->act+2;
		
	case CONVERT_CUSTOMMENU:
	if(!readpos)	//readpos will be zero if CONVERT_ACT didn't initalize it
		readpos=((IDBHeader*)inptr)->cust+2;
	
		while(dbptr[readpos])
		{
			len=dbptr[readpos++];
	
			if(writepos+len>allocsize)
			{
				//allocsize=writepos+len+CONVERT_BUFFER_SIZE;
				allocsize+=CONVERT_BUFFER_SIZE;
				if((h=HeapRealloc(h,allocsize))==H_NULL)
					break;
				txtptr=HeapDeref(h);
			}
			//len+=readpos;
			while(dbptr[readpos])//readpos<len)
			{
				txtptr[writepos++]=dbptr[readpos++];
			}
				readpos++;
				txtptr[writepos++]='\r';
		}
		
		txtptr[writepos-1]=0;
		
		HeapRealloc(h,writepos);
		return h;
		break;
		
	case CONVERT_ALIASES: //decompile Alias entries
		readpos=((IDBHeader*)inptr)->alias+2;
		
		while(dbptr[readpos])
		{
			//len_l=dbptr[readpos++];	//total length to next string...
			len=dbptr[readpos++];	//get the strlen byte (str1)

			if(writepos+len>allocsize)
			{
				allocsize+=CONVERT_BUFFER_SIZE;
				if((h=HeapRealloc(h,allocsize))==H_NULL)
					break;
				txtptr=HeapDeref(h);
			}
		
			strcpy(txtptr+writepos,dbptr+readpos);
			
			len=strlen(dbptr+readpos)+1;
			readpos+=len;
			writepos+=len-1;
			
			txtptr[writepos++]='\r';
			strcpy(txtptr+writepos,dbptr+readpos);
			
			len=strlen(dbptr+readpos);
			readpos+=len+1;
			writepos+=len;
			
				txtptr[writepos++]='\r';
		}

		txtptr[writepos-1]=0;
		
		HeapRealloc(h, writepos);
		return h;
		break;
		
	}
	
	return H_NULL;
}
