// C Source File
// Created 6/18/01; 1:25:01 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#include <tigcclib.h>

#include "DataBase.h"

void * OpenDataBase(char *file)
{
	SYM_ENTRY * sym;
	char TIFile[17];
	int i=strlen(file);
	static char db_tag[]={0,'I',' ','D','B',0,0xF8};
	
	if(i>17)
		return NULL;
		
	//convert to TI-OS style file names
		TIFile[0]=0;	
		file=strcpy(TIFile+1,file)+i;
			
		if((sym=SymFindPtr(file,0)))
		{
			file=HToESI(sym->handle);
						
			if(!memcmp(db_tag,file-6,7))
			{
				return HLock(sym->handle);
			}
		}
			
		return NULL;
}

int CloseDataBase(char *file)
{
	SYM_ENTRY * sym;
	char TIFile[17];
	int i=strlen(file);
	static char db_tag[]={0,'I',' ','D','B',0,0xF8};
	
	if(i>17)
		return FALSE;
		
	//convert to TI-OS style file names
		TIFile[0]=0;	
		file=strcpy(TIFile+1,file)+i;
			
		if((sym=SymFindPtr(file,0)))
		{
			file=HToESI(sym->handle);
			
			if(!memcmp(db_tag,file-6,7))
			{
				HeapUnlock(sym->handle);
				return TRUE;
			}
		}
	return FALSE;
}
