// C Source File
// Created 6/18/01; 3:17:51 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#include <tigcclib.h>

#include "ConvertDB.h"
#include "Resources.h"
#include "EditorSupport.h"
#include "EditorMenus.h"
#include "DataBase.h"
#include "Editor.h"
#include "Validate.h"

//global variables
	TEXT_EDIT *te_act, *te_cust, *te_alias;
	TEXT_EDIT *te_current;

	volatile HANDLE ghACT=H_NULL;
	volatile HANDLE ghCUST=H_NULL;
	volatile HANDLE ghALIAS=H_NULL;
	volatile HANDLE *hCurrent=NULL;
	//strange; 18 should be enough 8+1+8+1 but address errors happen... 19=ok
	char gdbname[19]={};
	
//The Text Editor...
void DoTextEditor()
{
	volatile HANDLE *hACT = &ghACT;
	volatile HANDLE *hALIAS = &ghALIAS;
	volatile HANDLE *hCUST = &ghCUST;
	
	char *db;
	char *dbname=gdbname;
	EVENT ev;
	char i;	//keeps track of what we're editing
	short mnuResult;	//the result from	menukey
	short bContinueLoop=TRUE;	//is the editor running?
	WIN_RECT TE_WINDOW={0,16+8,LCD_WIDTH,LCD_HEIGHT-13};
	
//for the menu structure to be created later...
	volatile HANDLE hMenuStruct;
	volatile HANDLE hMenu;

//Decompile the database into text form...
	if(!(db=OpenDataBase(dbname)))
	{
		dbname[0]=0;
		if(!MenuNewDataBase())	//on error, just do a file/new
			return;
	}
	else
	{
		*hACT=ConvertDB(db, CONVERT_ACT);
		*hCUST=ConvertDB(db, CONVERT_CUSTOMMENU);
		*hALIAS=ConvertDB(db, CONVERT_ALIASES);
		CloseDataBase(dbname);
	}
	
//build the Menu System
	hMenuStruct=MenuNew (2, 0, 0);

	BuildEditorMenu(hMenuStruct);

//prepare to display the editor
	ClrScr();
	ST_refDsp(10);
	
//Open the different Text Editors
	TE_open(te_cust,DeskTop,&TE_WINDOW, *hCUST, 0, 0, 3);
	TE_open(te_alias,DeskTop,&TE_WINDOW, *hALIAS, 0, 0, 3);
	TE_open(te_act,DeskTop,&TE_WINDOW, *hACT, 0, 0, 3);
	
	ChangeWindow(i=0);

//Show the menu system
	hMenu = MenuBegin(HLock (hMenuStruct), 0, 0, 0);

//enter the Event Loop (Main Loop)
	while(bContinueLoop)
	{
	//get the keypress and blink events to pass on
		EV_getc(ACTIVITY_NORMAL, &ev);
		
		if(ev.Type==CM_KEYPRESS)
			if((mnuResult=MenuKey(hMenu, ev.extra.Key.Code)))
			{
				switch(mnuResult)
				{
				//FILE
					case  3:	//new
						if(Validate())
						{
							if(!Editor_Save())
								dlg_help(WARN_LOW_RAM);
							MenuNewDataBase();
						}
						break;
					case  5:	//open
						if(Validate())
						{
							Editor_Open();
							i=0;
						}
						break;
					case 9:		//SaveAs
						if(Validate())
						{
							Editor_SaveAs();
							i=0;
						}
						break;
					case 11:	//exit
							EXIT_AND_SAVE();
						break;
				//EDIT
					case 43:	//cut
						ev.Type=CM_MENU_CUT;
						break;
					case 45:	//copy
						ev.Type=CM_MENU_COPY;
						break;
					case 47:	//paste
						ev.Type=CM_MENU_PASTE;
						break;
					case 49:	//select all
						TE_select(te_current,0,te_current->CurSize);
						break;
				//WINDOW
					case 63:	//Auto Complete Window
						ChangeWindow(i=0);
						break;
					case 65:	//Custom Menu Window
						ChangeWindow(i=1);
						break;
					case 67:	//Aliases Window
						ChangeWindow(i=2);
						break;
				//HELP
					case 83:	//Help
						dlg_help(TXT_HELP);
						break;
					case 85:	//About
						dlg_help(TXT_ABOUT);
				}
				
			////////////////////////////////////////////////////////////
			//handle switching of the active editor
				if(ev.extra.Key.Code==KEY_SWITCH)
					ChangeWindow(i = ++i>2 ? 0 : i);
					
				switch(ev.extra.Key.Code)
				{
					case KEY_VARLNK:
					{
						LCD_BUFFER SaveScr;
					
						LCD_save(SaveScr);
						EV_captureEvents((EVENT_HANDLER)EventHandler);
						EV_defaultHandler(&ev);
						EV_captureEvents(NULL);
						LCD_restore(SaveScr);
						ev.Type = CM_WPAINT;
					}
					break;
					
					case KEY_QUIT:
						EXIT_AND_SAVE();
					break;
					
					case KEY_ESC:
					case KEY_APPS:
						continue;
					break;
				}
			}
		
		///////////////////////////////////////////////////////////////////
		//send the event to the correct text editor
			TE_handleEvent(te_current, &ev);
	}

//close all text editors
	TE_close(te_act);
	TE_close(te_cust);
	TE_close(te_alias);

//reset the Global Variables
	hCUST=H_NULL;
	hALIAS=H_NULL;
	hACT=H_NULL;
	
//remove the menu
	MenuEnd(hMenu);
	HeapUnlock(hMenuStruct);
	HeapFree(hMenuStruct);
//MenuUpdate();	//restore the Home Screen Default Menu...

}

void EventHandler(EVENT *ev)
{	

	#ifdef OPTIMIZE_ROM_CALLS
		asm("move.l %a5,-(%sp) /*support for OPTIMIZE_ROM_CALLS*/");
		asm("move.l 0xC8,%a5	/*support for OPTIMIZE_ROM_CALLS*/");
		//void *__sjmp_tbl__=__jmp_tbl;
		//__jmp_tbl=(void*)0xC8;
	#endif
	
	if(ev->Type == CM_HSTRING)
		TE_handleEvent(te_current, ev);
	
	#ifdef OPTIMIZE_ROM_CALLS
		asm("move.l (%sp)+,%a5");
		//__jmp_tbl = __sjmp_tbl__;
	#endif
}
