// C Source File
// Created 6/19/01; 10:35:27 PM

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#include <tigcclib.h>

#include "Editor.h"
#include "Resources.h"
#include "EditorSupport.h"

void BuildEditorMenu(volatile HANDLE hMenuStruct)
{

//File Menu 1-20
MenuAddText(hMenuStruct, 0, ID_CMD, 						1, 0);
MenuAddText(hMenuStruct, 1, ID_CMD_NEW,					3, 0);
MenuAddText(hMenuStruct, 1, ID_CMD_OPEN,				5, 0);
//MenuAddText(hMenuStruct, 1, ID_CMD_SAVE,			7, 0);
MenuAddText(hMenuStruct, 1, ID_CMD_SAVE_AS,			9, 0);
MenuAddText(hMenuStruct, 1, ID_CMD_EXIT,				11, 0);

//Tools Menu 21-40
/*
MenuAddText(hMenuStruct, 0, "Tools", 						21, 0);
MenuAddText(hMenuStruct, 21, "Import", 					23, 0);
MenuAddText(hMenuStruct, 21, "Export", 					25, 0);
*/

//Edit Menu 41-60
MenuAddText(hMenuStruct, 0, ID_EDIT, 						41, 0);
MenuAddText(hMenuStruct, 41, ID_EDIT_CUT, 			43, 0);
MenuAddText(hMenuStruct, 41, ID_EDIT_COPY, 			45, 0);
MenuAddText(hMenuStruct, 41, ID_EDIT_PASTE,			47, 0);
MenuAddText(hMenuStruct, 41, ID_EDIT_SELALL,		49, 0);

//Window Menu	61-80
MenuAddText(hMenuStruct, 0,  ID_WINDOW, 				61, 0);
MenuAddText(hMenuStruct, 61, ID_WINDOW_AC,			63, 0);
MenuAddText(hMenuStruct, 61, ID_WINDOW_CU	, 		65, 0);
MenuAddText(hMenuStruct, 61, ID_WINDOW_AL, 			67, 0);

//About Menu 81-100
MenuAddText(hMenuStruct, 0, ID_HELP, 						81, 0);
MenuAddText(hMenuStruct, 81,ID_HELP_HELP, 			83, 0);
MenuAddText(hMenuStruct, 81,ID_HELP_ABOUT,			85, 0);
}


void ChangeWindow(unsigned int i)
{
	short x=FontSetSys(F_4x6);
	unsigned int j;
	char buff[75];
	char *txt[3]={ID_WINDOW_AC,ID_WINDOW_CU,ID_WINDOW_AL};
	short lcd_height=LCD_HEIGHT;
	short lcd_width=LCD_WIDTH;
	EVENT ev;
	
	for(j=0;j<6;j++)
	{
		DrawLine(0,16+j,lcd_width,16+j,A_NORMAL);
		DrawLine(0,lcd_height-12+j,lcd_width,lcd_height-12+j,A_NORMAL);
	}
	
	sprintf(buff,APP_TITLE " " APP_VERSION " - %s",gdbname);
	lcd_width/=2;
	DrawStr((lcd_width)-(strlen(buff)/2*4), 16, buff, A_REVERSE);
	DrawStr((lcd_width)-(strlen(txt[i])/2*6), lcd_height-12, txt[i], A_REVERSE);
	
	FontSetSys(x);
	
	switch(i)
	{
		case 1:	//Edit the Custom Menu
			te_current=te_cust;
			hCurrent=&ghCUST;
			break;	
		case 2:	//Edit the Auto Complete Text
			te_current=te_alias;
			hCurrent=&ghALIAS;
			break;
		case 0:	//Edit the Aliases
			te_current=te_act;
			hCurrent=&ghACT;
			break;
//		default:
//			ER_throwVar(15);
	}

	ev.Type = CM_WPAINT;
	TE_handleEvent(te_current, &ev);
	TE_focus(te_current);
}


short dlg_help(char *msg)
{
	return DlgMessage(APP_TITLE " " APP_VERSION, msg, BT_OK, BT_NONE);
}
