// C Header File
// Created 3/22/01; 4:49:24 PM
#ifndef AppDefh
#define AppDefh

//which language should be used:ENGLISH by default unless otherwise defined
#ifndef _FRENCH_
#ifndef _GERMAN_
#ifndef _ENGLISH_
#ifndef _SPANISH_

#define _ENGLISH_

#endif
#endif
#endif
#endif

//Version Control
#define APP_TITLE "MakeDB"
#define APP_VERSION "v1.0"

//the magic number that signals a good database
//it appears just after the length word in an i db file
//makes it easier to error check in ash
#define MAGIC_TAG 0xFFFF
unsigned int IDBShortTag=MAGIC_TAG;

//the tag for compiled databases
char CompiledTag[]={0,'I',' ','D','B',0,0xF8};
////////////////////////////////////////////////////////////////


#ifdef _ENGLISH_

//Section Headers for a decompiled database
#define CmdACT   "*AutoComplete*\n"	 //signals an act section
#define CmdALIAS "*Aliases*\n"			//signals a section of Alias Commands
#define CmdCME	 "*CustomMenu*\n"	 //signals a custom menu section

//Error Strings...
#define FATAL_ERR		"Fatal Error:\n%s"
#define ER_LOWRAM   "Low Ram"
#define ER_BADINPUT "Cannot open input file!"
#define ER_ARCHIVED "Output File is archived!"
#define ER_BADALIAS "Check input file alias section!"
#define ER_ARG1BAD  "Input arg must be a string."
#define ER_ARG2BAD  "Output arg must be a string."
#define ER_SAMENAME "Input and Output Files have the\nsame name!"
#define ER_INCOMPAT "Incompatible Database Version!"

//Informational Messages...
#define MSG_DECOMPILE " Decompiling..."
#define MSG_COMPILE   " Compiling..."
#define MSG_HELP      "  TO USE TYPE:\nmakedb(\"input\",\"output\")\n  OR\n" \
												"ttstart(\"makedb\",\"input\",\"output\")\n  if compressed."
#define MSG_STATS			"\n**Stats:"
#define MSG_ACTENTRY	"\n**%u ACT Entries"
#define MSG_ALIASES		"\n**%u Aliases"
#define MSG_CMEENTRY	"\n**%u Custom Menu Entries"

#endif

///////////////////////////////////////////////////////////////////////////

#ifdef _GERMAN_
//#warning MakeDB:Language=German
//Section Headers for a decompiled database
#define CmdACT   "*automatischeVervollstndigung*\n"	 //signals an act section
#define CmdALIAS "*Aliases*\n"			//signals a section of Alias Commands
#define CmdCME	 "*benutzerdefiniertesMen*\n"	 //signals a custom menu section

//Error Strings...
#define FATAL_ERR		"Schwerer Fehler:\n%s"
#define ER_LOWRAM   "wenig RAM"
#define ER_BADINPUT "kann Eingabedatei nicht ffnen!"
#define ER_ARCHIVED "Ausgabedatei ist archiviert!"
#define ER_BADALIAS "berprfen Sie den Alias der Eingabedatei!"
#define ER_ARG1BAD  "Eingabeargument mu eine Zeichenkette sein."
#define ER_ARG2BAD  "Ausgabeargument mu eine Zeichenkette sein."
#define ER_SAMENAME "Ein- und Ausgabedateiname sind gleich!"
#define ER_INCOMPAT "Inkompatible Datenbankversion!"

//Informational Messages...
#define MSG_DECOMPILE " dekompiliere..."
#define MSG_COMPILE   " kompiliere..."
#define MSG_HELP      "  VERWENDUNG:\nmakedb(\"input\",\"output\")\n  OR\n" \
												"ttstart(\"makedb\",\"input\",\"output\")\n  wenn komprimiert."
#define MSG_STATS			"\n**Statistiken:"
#define MSG_ACTENTRY	"\n**%u aV-Eintrge"
#define MSG_ALIASES		"\n**%u Aliases"
#define MSG_CMEENTRY	"\n**%u Benutzermen-Eintrge"

#endif

#ifdef _FRENCH_
//#warning MakeDB:Language=French
//Section Headers for a decompiled database
#define CmdACT   "*Autocompletion*\n"	 //signals an act section
#define CmdALIAS "*Alias*\n"			//signals a section of Alias Commands
#define CmdCME	 "*MenuCustom*\n"	 //signals a custom menu section

//Error Strings...
#define FATAL_ERR		"Erreur Fatale:\n%s"
#define ER_LOWRAM   "Niveau de Ram faible"
#define ER_BADINPUT "impossible d'ovrir le fichier d'entre!"
#define ER_ARCHIVED "Fichier de sortie archiv!"
#define ER_BADALIAS "verifiez la section des alias du fichier d'entre!"
#define ER_ARG1BAD  "l'argument d'entre doit etre une chaine."
#define ER_ARG2BAD  "l'argument de  sortie doit etre une chaine."
#define ER_SAMENAME "les fichiers d'entre-sortie on le meme nom"
#define ER_INCOMPAT "Version de base de donne incompatible!"

//Informational Messages...
#define MSG_DECOMPILE " Dcompilation..."
#define MSG_COMPILE   " Compilation..."
#define MSG_HELP      "  UTILISATION:\nmakedb(\"entre\",\"Sortie\")\n  OU\n" \
												"ttstart(\"makedb\",\"entre\",\"Sortie\")\n  Si compress."
#define MSG_STATS			"\n**Stats:"
#define MSG_ACTENTRY	"\n**%u Entres ACT"
#define MSG_ALIASES		"\n**%u Alias"
#define MSG_CMEENTRY	"\n**%u Entres du menu custom"

#endif

#ifdef _SPANISH_
//#warning MakeDB:Language=Spanish
//Section Headers for a decompiled database
#define CmdACT   "*CompletarAutomaticamente*\n"	 //signals an act section
#define CmdALIAS "*Alias*\n"			//signals a section of Alias Commands
#define CmdCME	 "*MenuPersonalizado*\n"	 //signals a custom menu section

//Error Strings...
#define FATAL_ERR		"Error Fatal:\n%s"
#define ER_LOWRAM   "Nivel de Ram bajo"
#define ER_BADINPUT "Imposible abrir el archivo de entrada!"
#define ER_ARCHIVED "Archivo de salida archivado!"
#define ER_BADALIAS "Verifique la seccin de los alias del archivo de entrada!"
#define ER_ARG1BAD  "el argumento de entrada debe ser una cadena."
#define ER_ARG2BAD  "el argumento de salida debe ser una cadena."
#define ER_SAMENAME "los archivos de entrada-salida tienen el mismo nombre"
#define ER_INCOMPAT "Versin de base de datos incompatible!"

//Informational Messages...
#define MSG_DECOMPILE " Decompilacin..."
#define MSG_COMPILE   " Compilacin..."
#define MSG_HELP      "  UTILIZACIN:\nmakedb(\"entrada\",\"salida\")\n  O\n" \
												"ttstart(\"makedb\",\"entrada\",\"salida\")\n si es comprimido."
#define MSG_STATS			"\n**Estadsticas:"
#define MSG_ACTENTRY	"\n**%u Entradas ACT"
#define MSG_ALIASES		"\n**%u Alias"
#define MSG_CMEENTRY	"\n**%u Entradas del menu personalizado"

#endif

#endif
