// C Source File
// Created 3/20/01; 11:02:34 PM

//MakeDB By Greg
//Purpose:
//to compile/decompile on calc text or data base files for
// A-Shell (ash)

#define OPTIMIZE_ROM_CALLS    //Use ROM Call Optimization
#define NO_EXIT_SUPPORT			 //No support for exit or atexit
#define SAVE_SCREEN					//save the screen (lazy way to erase help messages)

#define Msg(s) {ErrMessage(s);return;}

#include <tigcclib.h>         // Include All Header Files
#include "MakeAppDef.h"
#include "FileType.h"
#include "Message.h"
#include "IsArchived.h"
#include "CompileDB.h"
#include "DeCompileDB.h"

short _ti89;                   // Produce .89Z File
//short _ti92plus;              // Produce .9XZ File

// Main Function
void _main(void)
{
		ESI argptr;
		char *arg1=NULL;
		char *arg2=NULL;
		
		
	InitArgPtr(argptr);
	
		if(ArgCount()<2 || ArgCount()>3)
		{
			Message(MSG_HELP);
			return;
		}
		
		if(ArgCount()==3)	//assume that it was started with ttstart
			SkipArg(argptr);
		
			if(GetArgType(argptr)!=STR_TAG)
				Msg(ER_ARG1BAD);
				
			(const char*)arg1=GetStrnArg(argptr);
			
			if(GetArgType(argptr)!=STR_TAG)
				Msg(ER_ARG2BAD);
			
			(const char*)arg2=GetStrnArg(argptr);
			
			if(!strcmp(arg1,arg2))
				Msg(ER_SAMENAME);
				
			if(FileType(arg1)==FILE_TXT)
			{	
				ST_helpMsg(APP_TITLE " " APP_VERSION MSG_COMPILE);
				CompileTextFile(arg1,arg2);
				return;
			}
				
			if(FileType(arg1)==FILE_COMPILED)
			{
				ST_helpMsg(APP_TITLE " " APP_VERSION MSG_DECOMPILE);
				DecompileDataBase(arg1,arg2);
				return;
			}
			
		ErrMessage(ER_BADINPUT);
}
